//+------------------------------------------------------------------+
//|                                            PolyFitBands_v2.3.mq4 |
//|                             Copyright  2007-08, TrendLaboratory |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                   E-mail: igorad2003@yahoo.co.uk |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007-08, TrendLaboratory"
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_buffers   8
#property indicator_color1    LightSkyBlue
#property indicator_width1    1
#property indicator_style1    3
#property indicator_color2    LightSkyBlue
#property indicator_width2    2
#property indicator_color3    LightSkyBlue
#property indicator_width4    2
#property indicator_color4    DeepSkyBlue
#property indicator_width5    2
#property indicator_color5    DeepSkyBlue
#property indicator_width6    2
#property indicator_color6    Blue
#property indicator_width7    2
#property indicator_color7    Blue
#property indicator_width8    2
#property indicator_color8    Red

//---- external variables
extern int     Price          =   0;   //Apply to Price(0-Close;1-Open;2-High;3-Low;4-Median price;5-Typical price;6-Weighted Close)
extern int     Length         =  20;   //Number of bars for an evaluation
extern int     Degree         =   1;   //Degree of a Polynomial(no more 12)
extern int     PreSmooth      =   1;   //Period of Preliminary Smoothing
extern int     PreSmoothMode  =   0;   //Mode of MA:0-SMA,1-EMA,2-Wilders(SMMA),3-LWMA
extern double  K_Sigma1       =   1;   //Multiplier of Sigma(Standard Deviation)
extern double  K_Sigma2       =   2;   //Multiplier of Sigma(Standard Deviation)
extern double  K_Sigma3       =   3;   //Multiplier of Sigma(Standard Deviation)
extern int     FitMode        =   1;   //Fitting Mode: 0-Fitting,1-Moving
extern int     CenterMode     =   1;   //Center Line Plot: 0-without,1-with 
extern int     BarsBack       =   0;   //Shift in history 
extern int     CountBars      =   0;   //Maximum Number of Bars(0-all Bars) 
extern bool    ZeroBind       = true;
extern bool    Normalize      = false;
//---- indicator buffers
double Polynom[];
double UpBand1[];
double DnBand1[];
double UpBand2[];
double DnBand2[];
double UpBand3[];
double DnBand3[];
double Prices[];


//---- global variables
double PriceArray[];
int cBars;
datetime pUpTime = 0, pDnTime = 0, pTime;
int outbars=0, inbars=0, onbars=0;
bool fTime = true;
//+---------------------------------------------------------------------------+
//| Custom indicator initialization function                                  |
//+---------------------------------------------------------------------------+
int init()
{
   if(BarsBack < 0) BarsBack = 0;
   //IndicatorDigits(MarketInfo(Symbol(), MODE_DIGITS )+2);
   
   SetIndexBuffer(0, Polynom);
   SetIndexBuffer(1, UpBand1);
   SetIndexBuffer(2, DnBand1);
   SetIndexBuffer(3, UpBand2);
   SetIndexBuffer(4, DnBand2);
   SetIndexBuffer(5, UpBand3);
   SetIndexBuffer(6, DnBand3);
   SetIndexBuffer(7, Prices);
      
   if(CountBars == 0) cBars = Bars - (Length+PreSmooth-2);
   else cBars = CountBars+1;

   for (int i=0; i<8; i++) SetIndexDrawBegin(i,Bars-cBars-2);
   string short_name="PolyFitBands("+Price+","+Length+","+Degree+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"PolyFitCenter");
   SetIndexLabel(1,"UpPolyBand");
   SetIndexLabel(2,"DnPolyBand");
   
   ArrayResize(PriceArray, Length);
      
   return(0);
}

double PolyFit(int mode,double price[],int deg,int len,int bar)
{
double   result=0,Sum=0;
double   AX[12,12],BX[12],ZX[12],Pow[12];
int      j,k,Row[12];  
static double CX[12];
      
   if (len<=1) Sum = price[bar];
   else
   {	
      if(mode == 1 || (mode == 0 && bar == -len+1))
      {
      for (j=1;j<=deg+1;j++) BX[j]=0;
		
         for (k=1;k<=len;k++) 
  	      {
  	      double YK=price[len-k];
  	      double XK=k;
  	      double Prod=1;
  	         for (j=1;j<=deg+1;j++)
            {
    	      BX[j]+= YK*Prod;
    	      Prod*=XK;
  		      }
         }
      
      for (j=0;j<=2*deg;j++) Pow[j]=0;
	
	   Pow[0]=len;
	
         for (k=1;k<=len;k++)
	      {
  	      XK=k;
  	      Prod=k;
  	         for (j=1;j<=2*deg;j++)
  	         {
    	      Pow[j]+= Prod;    	   
    	      Prod*= XK;
  		      }
         }	
	
	      for (j=1;j<=deg+1;j++)
	      {	
            for (int l=1;l<=deg+1;l++) 
  	         AX[j,l]=Pow[j+l-2];
         }	

	  for (j=1;j<=deg+1;j++) Row[j]=j;
  	
         for (int i=1;i<=deg;i++)
  	      {
  	         for (k=i+1;k<=deg+1;k++)
            {
               if(MathAbs(AX[Row[k],i]) > MathAbs(AX[Row[i],i]))
      	      {	
      	      int Temp=Row[i];
      	      Row[i]=Row[k];
      	      Row[k]=Temp;
               }
            }

            for (k=i+1;k<=deg+1;k++)
    	      {
    	      if(AX[Row[i],i]!=0) AX[Row[k],i]=AX[Row[k],i]/AX[Row[i],i];
    		      for (l=i+1;l<=deg+1;l++)
      	      AX[Row[k],l]=AX[Row[k],l]-AX[Row[k],i]*AX[Row[i],l];
    		   }
         }

      ZX[1]=BX[Row[1]];
      
         for (k=2;k<=deg+1;k++)
  	      {
  	      Sum=0;
         for (l=1;l<=k-1;l++) Sum+=AX[Row[k],l]*ZX[l];
  	   
  	      ZX[k]=BX[Row[k]]-Sum;
	      }
     
      if(AX[Row[deg+1],deg+1] != 0) CX[deg+1]=ZX[deg+1]/AX[Row[deg+1],deg+1];
      	
         for (k=deg;k>=1;k--)
  	      {
  	      Sum=0;
	    		
  	      for (l=k+1;l<=deg+1;l++) Sum += AX[Row[k],l]*CX[l]; 
  	      CX[k]=(ZX[k]-Sum)/AX[Row[k],k];
	      }
      }
      	  
	Sum=CX[deg+1];
	for (k=deg;k>=1;k--) Sum=CX[k]+Sum*(len + bar);
   }
   return (Sum);
}	
//+------------------------------------------------------------------+
//| PolyFitBands_v2.3                                                     |
//+------------------------------------------------------------------+
int start()
{
   int i, j, k, m, shift, counted_bars=IndicatorCounted(), limit;
        
   
   if ( counted_bars < 0 )  return(0);
   if ( counted_bars ==0 )  limit=cBars-1; 
         
   if (FitMode==1 && counted_bars > 0) {limit = Bars - counted_bars + BarsBack; int len = Length+PreSmooth;}
   else
   if (FitMode==0) {limit = Length + BarsBack; len = cBars - Length+1;} 
   
   if ( counted_bars < 1 || FitMode==0)
   { 
      for(i=1;i<len;i++)
      { 
      Polynom[cBars-i]=EMPTY_VALUE; 
      UpBand1[cBars-i]=EMPTY_VALUE;
      DnBand1[cBars-i]=EMPTY_VALUE;
      UpBand2[cBars-i]=EMPTY_VALUE;
      DnBand2[cBars-i]=EMPTY_VALUE;
      UpBand3[cBars-i]=EMPTY_VALUE;
      DnBand3[cBars-i]=EMPTY_VALUE;
      }
   }   
      
     
   for(shift=BarsBack;shift<limit;shift++ )
   {
      if(shift < cBars)
      {
         if((shift==BarsBack && FitMode==0) || (FitMode==1))
         {   
            for(j=0;j<Length;j++) 
            PriceArray[j] = iMA(NULL,0,PreSmooth,0,PreSmoothMode,Price,shift*FitMode + j + (1-FitMode)*BarsBack);
      
            double Sum=0;
            for(j=Length-1;j>=0;j--)
            {
            double poly = PolyFit(0,PriceArray,Degree,Length,-j); 
            double del = PriceArray[j] - poly; 
            Sum += del*del;
            if (FitMode==0) Polynom[j+BarsBack] = poly;  
            }
      
         if(FitMode==1) Polynom[shift] = poly; 
      
            if (Length-1 > 0 && Sum > 0)
            {
               if(Length < 32) double StdDev = MathSqrt(Sum/(Length-1));   
               else
               StdDev = MathSqrt(Sum/Length);       
            }
         }
      
      //
      //
      //
      //
      //
      
      double tKSigma1     = K_Sigma1;
      double tKSigma2     = K_Sigma2;
      double tKSigma3     = K_Sigma3;
      double polyOriginal = Polynom[shift];
      double price        = iMA(NULL,0,1,0,MODE_SMA,Price,shift);
      if (ZeroBind)
      {
         price          = price-Polynom[shift];
         Polynom[shift] = 0;
         if (Normalize) 
         {
               double maxSigma = StdDev*MathMax(MathMax(K_Sigma1,K_Sigma2),K_Sigma3);
                  tKSigma1 = K_Sigma1/maxSigma;
                  tKSigma2 = K_Sigma2/maxSigma;
                  tKSigma3 = K_Sigma3/maxSigma;
                  price    = price   /maxSigma;
         }
      }            
      if (tKSigma1 > 0) UpBand1[shift] = Polynom[shift] + tKSigma1 * StdDev;    
      if (tKSigma1 > 0) DnBand1[shift] = Polynom[shift] - tKSigma1 * StdDev;
      if (tKSigma2 > 0) UpBand2[shift] = Polynom[shift] + tKSigma2 * StdDev;    
      if (tKSigma2 > 0) DnBand2[shift] = Polynom[shift] - tKSigma2 * StdDev;
      if (tKSigma3 > 0) UpBand3[shift] = Polynom[shift] + tKSigma3 * StdDev;    
      if (tKSigma3 > 0) DnBand3[shift] = Polynom[shift] - tKSigma3 * StdDev;
      Prices[shift]  = price;
      if(CenterMode==0) Polynom[shift] = EMPTY_VALUE;
      }
   }             
   return(0);
}
//+---------------------------------------------------------------------------+


